<?
/* numbers2words -numbers2words.php-

   converts numbers to words

   numbers range from 0 to 999.999.999.999.999

   Note: argument to n2w is a string use
   strings for big number (usally bigger then 2^32)
   see example.php

   For british (GB) numbers call with a optional
   second argument = 1.

   British (GB)
   n2w('1000000000',1) gives "one milliard"
   n2w('1000000000000',1) gives "one billion"

   American (US/FR)
   n2w('1000000000') gives "one billion"
   n2w('1000000000000') gives "one trillion"

   Version 0.2b
   Last change: 2002/09/30
   copyrigth 2002 Email Communications, http://www.emailcommunications.nl/
   written by Bas Jobsen (bas@startpunt.cc)
   
   Spanish translations and n2valuta funtion
   written by Ivan <igg10@alu.ua.es>
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

class numberstowords
{
	
        //var $language;
        var $lasts;
	var $teens;
	var $teen;
	var $teen1;
	var $teenmany;
	var $hundred;
	var $and;
	var $many;
	var $valuta;
	var $cents;

function numberstowords($language='us',$valuta='dollar')
{


        //$this->language=$language;

        switch($language)
 	{
 		case 'us':
 		$this->lasts=array('one','two','three','four','five','six','seven','eight','nine');
		$this->teens=array('eleven','twelve','thirteen','fourteen','fifteen','sixteen','seventeen','eightteen','nineteen');
		$this->teen=array('ten','twenty','thirty','fourty','fifty','sixty','seventy','eighty','ninety');
		$this->teen1='';
		$this->teenmany=' ';
		$this->hundred='hundred';
		$this->and='and';
		$this->many=array('', ' thousand ',' million ',' milliard ',' billion ');
 		break;
 		case 'uk':
 		$this->lasts=array('one','two','three','four','five','six','seven','eight','nine');
		$this->teens=array('eleven','twelve','thirteen','fourteen','fifteen','sixteen','seventeen','eightteen','nineteen');
		$this->teen=array('ten','twenty','thirty','fourty','fifty','sixty','seventy','eighty','ninety');
		$this->teen1='';
		$this->teenmany=' ';
		$this->hundred='hundred';
		$this->and='and';
		$this->many=array('', ' thousand ',' million ',' milliard ',' billion ');
 		break;
 		case 'es':
 		$this->lasts=array('un','dos','tres','cuatro','cinco','seis','siete','ocho','nueve');
		$this->teens=array('once','doce','trece','catorce','quince','dieciseis','diecisiete','dieciocho','diecinueve');
		$this->teen=array('diez','veinte','treinta','cuarenta','cincuenta','sesenta','setenta','ochenta','noventa');
		$this->teen1=' y ';
		$this->teenmany=' y ';
		$this->hundred=array('ciento','doscientos','trescientos','cuatrocientos','quinientos','seiscientos','setecientos','ochocientos','novecientos');
                $this->and='con';
		$this->many=array('', ' mil ',' millon ',' billon ',' trillon ');
        break;
        case 'nl':
 		$this->lasts=array('een','twee','drie','vier','vijf','zes','zeven','acht','negen');
		$this->teens=array('elf','twaalf','dertien','veertien','vijfteen','zestien','zebenteem','achtien','negentien');
		$this->teen=array('tien','twintig','dertig','viertig','vijftig','zestig','zeventig','tachtig','negentig');
		$this->hundred='honderd';
		$this->teen1='';
		$this->teenmany=' ';
		$this->and='en';
		$this->many=array('', ' duizend ',' miljoen ',' miljard ',' triljoen ');
        break;

 	}


        $this->valuta=$valuta;
        if($language!='nl')$this->valuta.='s';

        if($language=='es')$this->cents='cntimos';
        else $this->cents='cent';
        if($language!='nl')$this->cents.='s';
}	

function hunderds($number)
{

	$test=$number*1;
	if (empty($test))return;
	/* written by bas@startpunt.cc */
	
	$string='';
	$j=strlen($number);
	$done=false;
	for($i=0; $i<strlen($number); $i++)
	{
		

		if($j==2) 
		{
		if(strlen($number)>2)
		{
                if(is_array($this->hundred))
                {
                if($number[0]!=0)$string.=' '.$this->hundred[$number[0]-1];	
                }	
                else 
                {
                if($number[0]!=0)$string.= ' '.$this->hundred.' ';
				if(substr($number,$i+1))$string.= $this->and.' ';
                }
		}
		if ($number[$i]==1)
		{
			if($number[$i+1]==0) $string.=$this->teen[$number[$i]-1];
			else 
			{
			$string.=$this->teens[$number[$i+1]-1].$this->teen1;
			$done=true;
			}
		}
		else
		{
			if(!empty($this->teen[$number[$i]-1]))$string.=$this->teen[$number[$i]-1].$this->teenmany;
		}
	}

		elseif($number[$i]!=0 && !$done) $string.=$this->lasts[$number[$i]-1];

		$j--;
	}

return $string;
}	

function n2w($number,$uk=0)
{
	if(!is_string($number))$number.="";
	$string='';
	if(strlen($number)%3!=0)
	{
	$string.=$this->hunderds(substr($number,0, strlen($number)%3 ));
	$string.=$this->many[floor(strlen($number)/3)];
		
	}
	for($i=0; $i<floor(strlen($number)/3); $i++)
	{
		
		$string.=$this->hunderds(substr($number,strlen($number)%3+($i*3),3));
		if($number[strlen($number)%3+($i*3)]!=0)$string.=$this->many[floor(strlen($number)/3)-1-$i];

	}	

	return $string;
}


function n2valuta($number,$separator='.')
{
list($euros,$centimos) = explode($separator,$number);

$money = $this->n2w($euros);
$money .= ' '.$this->valuta;
if(!empty($centimos) and $centimos>0)
{
$money .= ' '.$this->and.' ';
$money .= $this->n2w($centimos);
$money .= ' '.$this->cents;
}
return($money);
}

}
?>